package com.mooctest.export;

import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.FutureTask;

@Controller
public class ExportController {
    @Autowired
    ExportService exportService;

    @Value("${export.path}")
    private String exportPath;

    @Value("${crowd.frontend}")
    private String crowdFrontend;

    @PostMapping("/generateReport")
    @ResponseBody
    public String getReport(@RequestBody JSONObject jsonParam) {
//        String res = exportService.getData(examId,caseId);
        List<Object> projects = (List<Object>) jsonParam.get("projects");
        Map<String,Object> data = (Map<String, Object>) projects.get(0);
        System.out.println("data "+ data.toString());
        List<Object> repports = (List<Object>) data.get("reports");
        List<FinalReportDTO>datas = toReportDto(repports);
        System.out.println("exportPath " + exportPath + "/excel-"+datas.get(0).getExamId()+"-"+datas.get(0).getCaseId()+".xls");
        File file=new File(exportPath + "/excel-"+datas.get(0).getExamId()+"-"+datas.get(0).getCaseId()+".xls");
        DoExportRunner ctt = new DoExportRunner(datas);
        FutureTask<Integer> ft = new FutureTask<>(ctt);
        ExecutorService executorService = Executors.newFixedThreadPool(1);
        executorService.execute(ft);
        String result = "wait";
        if (file.exists()){
            //todo 上传到oss 再返回oss
            //文件存在。
            result = crowdFrontend + exportPath + "/excel-" + datas.get(0).getExamId() + "-" + datas.get(0).getCaseId() + ".xls";
        }
        System.out.println(result);
        return result;
    }


    private List<FinalReportDTO> toReportDto(List<Object> data ){
        List<FinalReportDTO> res = new ArrayList<>();
        FinalReportDTO temp;
        data.forEach(s->{
            res.add(new FinalReportDTO((LinkedHashMap<String,Object>) s ));
        });
        return res;
    }




//    @GetMapping("/generateReport")
//    public String getReport(@RequestParam("projects") String projects,
//                            @RequestParam("menus") String menus,
//                            @RequestParam("projectStatistics")String projectStatistics) {
//
//        return "";
//    }


}