package com.mooctest.export;

import lombok.Data;

import java.util.ArrayList;
import java.util.Date;
import java.util.Map;

@Data
public class FinalReportDTO {
    private long id;

    private String description;

    private String[] imgUrls;

    private int severity;

    private int recurrent;

    private int category;

    private long writerId;

    private String sourceId;

    private Date createTime;

    private long examId;

    private long caseId;

    public FinalReportDTO(Map<String , Object > data){
        this.caseId =(Integer) data.get("caseId");
        this.category=(Integer) data.get("category");
        this.createTime = new Date((Long) data.get("createTime"));
        this.description = (String) data.get("description");
        this.examId = (Integer) data.get("examId");
        this.id=(Integer) data.get("id");
        String imsStr = (String)data.get("imgUrls");
        if(imsStr!=null&&imsStr.length()!=0){
            this.imgUrls = wrapImgStr(imsStr);
        }
        this.recurrent = (Integer) data.get("recurrent");
        this.severity = (Integer) data.get("severity");
        this.writerId = (Integer) data.get("writerId");
    }

    private String [] wrapImgStr(String imsStr){
        String temp [] = imsStr.split(",");
        ArrayList<String> res = new ArrayList<>();
        for(int i =0;i<temp.length;i++){
            if(temp[i]!=null&&temp[i].length()!=0){
                res.add(temp[i]);
            }
        }
        return (String[]) res.toArray( new String[res.size()]);
    }
}
